#
# spec file for package python-typing_extensions
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%define modname typing_extensions
%{?!python_module:%define python_module() python-%{**} python3-%{**}}
Name:           python-typing_extensions
Version:        3.7.2
Release:        lp152.3.2
Summary:        Backported and Experimental Type Hints for Python 35+
License:        Python-2.0
Group:          Development/Languages/Python
URL:            https://github.com/python/typing/
Source0:        https://files.pythonhosted.org/packages/source/t/typing_extensions/%{modname}-%{version}.tar.gz
Patch0:         test-sys-executable.patch
BuildRequires:  %{python_module setuptools}
BuildRequires:  %{python_module typing}
%if 0%{?suse_version} > 1320
BuildRequires:  python3-testsuite
%endif
BuildRequires:  fdupes
BuildRequires:  python-rpm-macros
%if %{python3_version_nodots} < 35
Requires:       python3-typing
%endif
%ifpython2
Requires:       python2-typing
%endif
BuildArch:      noarch

%python_subpackages

%description
The ``typing`` module was added to the standard library in Python
3.5 on a provisional basis and will no longer be provisional in
Python 3.7. However, this means users of Python 3.5 - 3.6 who are
unable to upgrade will not be able to take advantage of new types
added to the ``typing`` module, such as ``typing.Text`` or
``typing.Coroutine``.

The ``typing_extensions`` module contains both backports of these
changes as well as experimental types that will eventually be
added to the ``typing`` module, such as ``Protocol``.

Users of other Python versions should continue to install and use
the ``typing`` module from PyPi instead of using this one unless
specifically writing code that must be compatible with multiple
Python versions or requires experimental types.

%prep
%setup -q -n %{modname}-%{version}
%patch0 -p2

%build
%python_build

%install
%python_install
%fdupes %{buildroot}%{python3_sitelib}

%check
# X.Y -> X
%{python_expand current_bin_suffix=%{$python_bin_suffix}
$python src_py${current_bin_suffix:0:1}/test_typing_extensions.py
}

%files %{python_files}
%license LICENSE
%doc README.rst
%{python_sitelib}/*

%changelog
* Sat Mar  2 2019 Tomáš Chvátal <tchvatal@suse.com>
- Rebase the patch to the current git state
* Sat Mar  2 2019 John Vandenberg <jayvdb@gmail.com>
- Add support for Python <3.5, using upstream commit as
  test-sys-executable.patch to fix the tests, replacing custom sed.
- Remove unnecessary buid dependency on pytest and pytest-xdist
* Thu Feb 28 2019 Tomáš Chvátal <tchvatal@suse.com>
- Drop the old tarball
* Thu Feb 28 2019 John Vandenberg <jayvdb@gmail.com>
- Replace test_modules.tar.gz with python-testsuite
- Remove fix_tests.patch which is half fixing test_modules.tar.gz,
  and the other half is replaced with a less brittle sed.
- Remove unnecessary build dependencies
- Update to 3.7.2
  * Pass *args and **kwargs to superclass in Generic.__new__
  * Fix for issue #524
  * Fix typing_extensions to support PEP 560
  * Add annotations to NamedTuple children __new__ constructors
  * Add missing 'NoReturn' to __all__ in typing.py
  * Backport Generic.__new__ fix
  * Fix IO.closed to be property
  * Add Final to typing_extensions
  * Fix instance/subclass checks of functions against runtime protocols
  * Add Literal[...] types to typing_extensions
* Tue Oct 23 2018 Matej Cepl <mcepl@suse.com>
- Initial effort to package typing_extensions-3.6.6
